/*
 * Copyright (c) 2008, Noel Lemouel
 * All rights reserved.
 */

#include <pic32-io.h>
#include "gpio.h"

int gpio_init(unsigned int gpio, unsigned int base)
{
   port_sfr_t* portx;
   portx = (port_sfr_t*)base;

   /* set multiplexed pads as GPIOs */

   /* PORTB multiplexed with ANX */
   if(base == PORTB_BASE)
   {
      /* set corresponding bit in AD1PCFG */
      *(unsigned int*)0xbf809060 |= 1 << gpio;
   }

   // x_printf("AD1PCFG: 0x%08x\r\n", *(unsigned int*)0xbf809060);

   gpio_direction_input(gpio, base);

   return 0;
}

int gpio_direction_input(unsigned int gpio, unsigned int base)
{
   port_sfr_t* portx;
   portx = (port_sfr_t*)base;

//   if(gpio<0 || gpio>8) return -1;

   portx->tris |= 1 << gpio;

   return 0;
}

int gpio_direction_output(unsigned int gpio, unsigned int base)
{
   port_sfr_t* portx;
   portx = (port_sfr_t*)base;

//   if(gpio<0 || gpio>8) return -1;

   portx->tris &= ~(1 << gpio);

   return 0;
}

int gpio_get_value(unsigned int gpio, unsigned int base)
{
   port_sfr_t* portx;
   portx = (port_sfr_t*)base;

//   if(gpio<0 || gpio>8) return -1;
   
   return ((portx->port) >> gpio) & 0x0001;
}

int gpio_set_value(unsigned int gpio, int value, unsigned int base)
{
   port_sfr_t* portx;
   portx = (port_sfr_t*)base;

//   if(gpio<0 || gpio>8) return -1;

   if(value){
      portx->port |= 1 << gpio;
   }else{
      portx->port &= ~(1 << gpio);
   }
   
   return 0;
}

