/*
 * Copyright (c) 2008, Noel Lemouel
 * All rights reserved.
 */

#ifndef __I2C_GPIO_H__
#define __I2C_GPIO_H__

#define I2C_IO_DIR_IN  0
#define I2C_IO_DIR_OUT 1

#define I2C_CTRL_RD 1
#define I2C_CTRL_WR 0

#define I2C_ACK   1
#define I2C_NOACK 0

typedef struct i2c_gpio_channel_data{
   unsigned int gpio_base;
   unsigned int scl_pin;
   unsigned int sda_pin;
   int udelay;
   int timeout;
} i2c_gpio_channel_data_t;

void i2c_set_channel(i2c_gpio_channel_data_t*);

void i2c_start(void);
void i2c_stop(void);

int i2c_read_byte(int);
int i2c_write_byte(int);
int i2c_set_ctrl(int, int);

#endif /* __I2C_GPIO_H__ */

