/*
 * Copyright (c) 2008, Noel Lemouel
 * All rights reserved.
 */

#include <stdarg.h>
#include <drivers/uart/uart.h>

int putchar(int c)
{
   uart1_putc((unsigned char)c);
   return c;
}

int getchar(void)
{
   return (int)uart1_getc();
}

void printf (const char *fmt, ...)
{
   char buf[128];
   char *s = buf;

   va_list args;

   va_start (args, fmt);

   vsprintf(buf, fmt, args);

   va_end (args);

   while(*s) putchar(*s++);
}

